{$E+} {$N+}    { <== must use these directives }
program DEMO6230;
uses  CRT,
      devices ; {Compile devices.pas to create a TPU file so u can use this}
var
   comno: byte;     { this is your com no }
   err  : integer;  { need to declare an interger variable for the error code }
   data : double;   { need to declare a double variable to receive your data }
   ch   : char;     { for readkey function }
   stat : integer;  { for readflag }

Procedure Locx (oldy,newy : integer);
begin
   if keypressed then begin clrscr; ch:=readkey; halt(0); end;
   gotoxy(35,oldy);
   write(' ');
   gotoxy(35,newy);
   write(chr(17));
   gotoxy(18,newy);
end;

begin

  ClrScr;
  writeln('Ŀ');
  writeln('  MODEL 6230 RS232 DEMO PROGRAM  ');
  writeln('');
  Write ('INPUT COM NO.   : ');
  Readln(comno);
  InitCom(comno,2400,err); { for this model the baudrate is fixed at 2400.
                             Valid com nos. are 1 to 5. }

  If err <> 0 then
     begin
         Writeln ( 'Communication Error ');
         Halt; { if there's an error then halt the program }
         { if you are encountering an error here please check your cable
           and the connections, be sure that you are using the right
           COM no. and that COM port exists in your computer }
     end;

gotoxy(1,5);
highvideo;
writeln ('[ LCD DISPLAY ]');
lowvideo;
writeln ('mV    DISPLAY  : ');
writeln ('pH    DISPLAY  : ');
writeln ('Temp. DISPLAY  : ');
highvideo;
writeln ('[ ANNUNCIATORS ]');
lowvideo;
writeln ('pH annunciator : ');
writeln ('mV annunciator : ');
writeln ('MANUAL annunc. : ');
writeln ('ATC    annunc. : ');
writeln ('LOBAT  annunc. : ');
writeln ('STAND  annunc. : ');
writeln ('SLOPE  annunc. : ');
writeln ('AUTOLOCK       : ');
writeln ('WAIT  annunc. : ');
gotoxy(1,22);
writeln ('Press any key to exit....');
highvideo;

  repeat
     { Valid parameters for model 6230
       102 = mV display
       103 = pH display
       104 = temperature display
{    ***for readflag routine
       106 = readflag parameter
      allowed bit nos. for readflag =
              0 not supported
              1 not supported
              2 not supported
              3 not supported
              4 =wait
              5 =autolock
              6 =slope led
              7 =stand led
              8 =lobat
              9 =atc led
             10=manual led
             11=mV
             12=pH
}

     { read man6230.txt for explanation of errors }
     locx(18,6);
     ReadData (102,data,err); {get mV display }
     if err = 0 then writeln (data:0:0,'          ' ) else
           Begin
             If err>0 then writeln('Er ',Err) else writeln('Com Error ',err);
           end;
     locx(6,7);
     ReadData (103,data,err); {get pH display }
     if err = 0 then writeln (data:0:2,'          ' ) else
           Begin
             If err>0 then writeln('Er ',Err) else writeln('Com Error ',err);
           end;
     locx(7,8);
     ReadData (104,data,err); {get Temperature display }
     if err = 0 then writeln (data:0:1,'          ' ) else
           Begin
             If err>0 then writeln('Er ',Err) else writeln('Com Error ',err);
           end;
{ *** readflags *** }

{ **** conc.  }
{ **** pH  }
locx (8,10);
readflag(106,12,stat,err);
if stat =1 then write('ON ') else write('OFF');
{ **** mV  }
locx (10,11);
readflag(106,11,stat,err);
if stat =1 then write('ON ') else write('OFF');
{ **** Manual  }
locx (11,12);
readflag(106,10,stat,err);
if stat =1 then write('ON ') else write('OFF');
{ **** ATC  }
locx (12,13);
readflag(106,9,stat,err);
if stat =1 then write('ON ') else write('OFF');
{ **** LOBAT  }
locx (13,14);
readflag(106,8,stat,err);
if stat =1 then write('ON ') else write('OFF');
{ **** STAND  }
locx (14,15);
readflag(106,7,stat,err);
if stat =1 then write('ON ') else write('OFF');
{ **** Slope  }
locx (15,16);
readflag(106,6,stat,err);
if stat =1 then write('ON ') else write('OFF');
{ **** autolock  }
locx (16,17);
readflag(106,5,stat,err);
if stat =1 then write('ON ') else write('OFF');
{ **** wait  }
locx (17,18);
readflag(106,4,stat,err);
if stat =1 then write('ON ') else write('OFF');

     until 1=0
end.
